unit Frame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, CalendarX, ComCtrls, StdCtrls, Clipbrd, jpeg, GIFImage,
  Param, GrphPrev, ShellAPI;

var
  CF_JFIF: Word;

type
  TFrameForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    PrintPreview1: TMenuItem;
    X1: TMenuItem;
    Editting: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Help1: TMenuItem;
    SearchforHelpOn1: TMenuItem;
    About1: TMenuItem;
    N2: TMenuItem;
    Panel1: TPanel;
    ScrollBox1: TScrollBox;
    CalendarX1: TCalendarX;
    Label1: TLabel;
    Edit1: TEdit;
    UpDown1: TUpDown;
    Label2: TLabel;
    Button1: TButton;
    Label3: TLabel;
    Edit2: TEdit;
    UpDown2: TUpDown;
    Label4: TLabel;
    Label5: TLabel;
    Edit3: TEdit;
    UpDown3: TUpDown;
    Label6: TLabel;
    Label7: TLabel;
    Edit4: TEdit;
    UpDown4: TUpDown;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Label8: TLabel;
    Edit5: TEdit;
    UpDown5: TUpDown;
    Label9: TLabel;
    Edit6: TEdit;
    Label10: TLabel;
    Edit7: TEdit;
    UpDown6: TUpDown;
    UpDown7: TUpDown;
    Label11: TLabel;
    Edit8: TEdit;
    UpDown8: TUpDown;
    Label12: TLabel;
    Edit9: TEdit;
    UpDown9: TUpDown;
    Label13: TLabel;
    Edit10: TEdit;
    UpDown10: TUpDown;
    Label14: TLabel;
    Edit11: TEdit;
    UpDown11: TUpDown;
    Label15: TLabel;
    Edit12: TEdit;
    UpDown12: TUpDown;
    Label16: TLabel;
    Edit13: TEdit;
    Label17: TLabel;
    Edit14: TEdit;
    Button2: TButton;
    FontDialog1: TFontDialog;
    OpenDialog1: TOpenDialog;
    Save1: TMenuItem;
    N3: TMenuItem;
    T1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Parameter1: TParameter;
    PrintDialog1: TPrintDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    Bitmap1: TMenuItem;
    Metafile1: TMenuItem;
    JPEG1: TMenuItem;
    GIF1: TMenuItem;
    Text1: TMenuItem;
    Option1: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure PrintPreview1Click(Sender: TObject);
    procedure T1Click(Sender: TObject);
    procedure X1Click(Sender: TObject);
    procedure SearchforHelpOn1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Bitmap1Click(Sender: TObject);
    procedure Metafile1Click(Sender: TObject);
    procedure JPEG1Click(Sender: TObject);
    procedure GIF1Click(Sender: TObject);
    procedure Text1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure CalendarX1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private 錾 }
    function Stream2Clipboard(Format: Word; MemStream: TMemoryStream): Boolean;
    function Clipboard2Stream(Format: Word; MemStream: TMemoryStream): Boolean;
    procedure GetJPEG; // Nbv{[h JPEG `̃f[^荞ގ葱
    procedure GetGIF; // Nbv{[h GIF `̃f[^荞ގ葱
  public
    { Public 錾 }
    OrgBitmap: TBitmap;
    function SizeOfFile(FileName: String): String;
    function GraphicType: Integer;
    procedure MakeOrgBitmap;
  end;

var
  FrameForm: TFrameForm;

implementation

uses Preview;

{$R *.DFM}

function TFrameForm.Stream2Clipboard(Format: Word; MemStream: TMemoryStream): Boolean;
var
  Data: THandle;
  DataPtr: Pointer;
begin
  Result := False;
  if MemStream.Size = 0 then
    Exit;
  Data := GlobalAlloc(GMEM_MOVEABLE or GMEM_DDESHARE, MemStream.Size);
  try
    DataPtr := GlobalLock(Data);
    try
      MemStream.Position := 0;
      MemStream.ReadBuffer(DataPtr^, MemStream.Size);
      MemStream.Position := 0;
    finally
      GlobalUnlock(Data);
    end;
    Clipboard.SetAsHandle(Format, Data);
  except
    GlobalFree(Data);
    raise;
  end;
  Result := True;
end;

function TFrameForm.Clipboard2Stream(Format: Word; MemStream: TMemoryStream): Boolean;
var
  Data: THandle;
  DataPtr: Pointer;
  MSize: Integer;
  MPtr: Pointer; // ꎞǂݍݗpobt@
begin
  Result := False;
  Data := Clipboard.GetAsHandle(Format);
  if Data = 0 then
    Exit;
  DataPtr := GlobalLock(Data);
  if DataPtr = Nil then
    Exit;
  try
    MSize :=  GlobalSize(Data);
    GetMem(MPtr, MSize);
    try
      Move(DataPtr^, MPtr^, MSize); // Uobt@ɓǂݍ
      MemStream.Position := 0;
      MemStream.WriteBuffer(MPtr^, MSize); // 炽߂MemoryStreamɏ
      MemStream.Position := 0;
    finally
      FreeMem(MPtr);
    end;
  finally
    GlobalUnlock(Data);
  end;
  Result := True;
end;

procedure TFrameForm.GetJPEG;
var
  Jpeg: TJPEGImage;
  MemStream: TMemoryStream;
begin
  Jpeg := TJPEGImage.Create;
  Jpeg.CompressionQuality := UpDown1.Position;
  try
    MemStream := TMemoryStream.Create;
    try
      Clipboard2Stream(CF_JFIF, MemStream);
      Jpeg.LoadFromStream(MemStream);
      CalendarX1.Picture.Assign(Jpeg);
    finally
      MemStream.Free;
    end;
  finally
    Jpeg.Free;
  end;
end;

procedure TFrameForm.GetGIF;
var
  Gif: TGIFImage;
  MemStream: TMemoryStream;
begin
  Gif := TGIFImage.Create;
  try
    MemStream := TMemoryStream.Create;
    try
      Clipboard2Stream(CF_GIF, MemStream);
      Gif.LoadFromStream(MemStream);
      CalendarX1.Picture.Assign(Gif);
    finally
      MemStream.Free;
    end;
  finally
    Gif.Free;
  end;
end;

{ ݂̉摜 OrgBitmap ɕۑ葱 }
procedure TFrameForm.MakeOrgBitmap;
begin
  if Assigned(OrgBitmap) then
    OrgBitmap.Free;

  OrgBitmap := TBitmap.Create;

  case GraphicType of
    0: Caption := Caption + 'Empty';
    1: Caption := Caption + 'JPEG';
    2: Caption := Caption + 'GIF';
    3: Caption := Caption + 'Bitmap';
    4: Caption := Caption + 'Metafile';
    5: Caption := Caption + 'Icon';
  else
    Caption := Caption + 'Others';
  end;

  if CalendarX1.Picture.Graphic = Nil then
    Exit;

  if (CalendarX1.Picture.Graphic is TBitmap) or
     (CalendarX1.Picture.Graphic is TJPEGImage) or
     (CalendarX1.Picture.Graphic is TGIFImage) then
    OrgBitmap.Assign(CalendarX1.Picture.Graphic)
  else
  begin
    OrgBitmap.Width := CalendarX1.Picture.Graphic.Width;
    OrgBitmap.Height := CalendarX1.Picture.Graphic.Height;
    OrgBitmap.Canvas.Draw(0, 0, CalendarX1.Picture.Graphic);
  end;
end;

{ t@C̃TCY𕶎\ŕԂ֐ }
function TFrameForm.SizeOfFile(FileName: String): String;
var
  i, j: Integer;
  SearchRec: TSearchRec;
begin
  Result := '0KB';
  FindFirst(FileName, faAnyFile, SearchRec);
  i := SearchRec.Size;
  FindClose(SearchRec);
  j := i div 1024;
  if (i mod 1024) <> 0 then
  begin
    if (j = 0) or ((i mod 1024) >= 512) then
      Inc(j);
    end;
  Result := IntToStr(j) + 'KB';
end;

{ ݂̃OtBbN̎ނԂ֐ }
function TFrameForm.GraphicType: Integer;
begin
  if CalendarX1.Picture.Graphic = Nil then
    Result := 0
  else if CalendarX1.Picture.Graphic is TJPEGImage then
    Result := 1
  else if CalendarX1.Picture.Graphic is TGIFImage then
    Result := 2
  else if CalendarX1.Picture.Graphic is TBitmap then
    Result := 3
  else if CalendarX1.Picture.Graphic is TMetafile then
    Result := 4
  else if CalendarX1.Picture.Graphic is TIcon then
    Result := 5
  else
    Result := 6;
end;

procedure TFrameForm.FormShow(Sender: TObject);
var
  FileName: TFileName;
begin
  Tag := 1;

  Parameter1.Init; // Parameter1 Ăep[^t@C烍[hB
  if Parameter1.Count > 0 then // p[^̃[hɐꍇ
  begin
    WindowState := TWindowState(Parameter1['WindowState']); // Integer ^̃f[^𓾂B
    if WindowState <> wsMaximized then
    begin
      Left := Parameter1['Left']; // Integer ^̃f[^𓾂B(Parameter1.VIntegers['Left'] ƓłB)
      Top := Parameter1['Top']; // Integer ^̃f[^𓾂B
      ClientWidth := Parameter1['ClientWidth']; // Integer ^̃f[^𓾂B
      ClientHeight := Parameter1['ClientHeight']; // Integer ^̃f[^𓾂B
    end;
    OpenDialog1.FileName := Parameter1.VStrings['OpenFile']; // String ^̃f[^𓾂B
    SaveDialog1.FileName := Parameter1.VStrings['SaveFile']; // String ^̃f[^𓾂B
    OpenDialog1.InitialDir := ExtractFileDir(OpenDialog1.FileName);
    SaveDialog1.InitialDir := ExtractFileDir(SaveDialog1.FileName);
    FontDialog1.Font.Name := Parameter1.VStrings['FontName']; // String ^̃f[^𓾂B
    FontDialog1.Font.Size := Parameter1['FontSize']; // Integer ^̃f[^𓾂B
    FontDialog1.Font.Style := Parameter1.VFontStyles['FontStyle']; // TFontStyle ^̃f[^𓾂B
    UpDown1.Position := Parameter1['StartYear']; // Integer ^̃f[^𓾂B
    UpDown2.Position := Parameter1['StartMonth']; // Integer ^̃f[^𓾂B
    UpDown3.Position := Parameter1['Count']; // Integer ^̃f[^𓾂B
    UpDown4.Position := Parameter1['StartPoint']; // Integer ^̃f[^𓾂B
    UpDown5.Position := Parameter1['RowB']; // Integer ^̃f[^𓾂B
    UpDown6.Position := Parameter1['ColB']; // Integer ^̃f[^𓾂B
    UpDown7.Position := Parameter1['RowC']; // Integer ^̃f[^𓾂B
    UpDown8.Position := Parameter1['ColC']; // Integer ^̃f[^𓾂B
    UpDown9.Position := Parameter1['DayH']; // Integer ^̃f[^𓾂B
    UpDown10.Position := Parameter1['DayW']; // Integer ^̃f[^𓾂B
    UpDown11.Position := Parameter1['GapH']; // Integer ^̃f[^𓾂B
    UpDown12.Position := Parameter1['GapW']; // Integer ^̃f[^𓾂B
    CheckBox1.Checked := Parameter1.VBools['SundayRed']; // Boolean ^̃f[^𓾂B
    CheckBox2.Checked := Parameter1.VBools['HolidayRed']; // Boolean ^̃f[^𓾂B
    CheckBox3.Checked := Parameter1.VBools['Lines']; // Boolean ^̃f[^𓾂B
    Edit13.Text := Parameter1.VStrings['CalendarLeft']; // String ^̃f[^𓾂B
    Edit14.Text := Parameter1.VStrings['CalendarTop']; // String ^̃f[^𓾂B
  end
  else // p[^[hoȂꍇ
  begin
    Parameter1.Add('CalendarX ݒt@C --- ̃t@ĆAҏWȂŉB');
    Parameter1['WindowState'] := Integer(WindowState);
    Parameter1['Left'] := Left;
    Parameter1['Top'] := Top;
    ClientWidth := 688; Parameter1['ClientWidth'] := ClientWidth;
    ClientHeight := 447; Parameter1['ClientHeight'] := ClientHeight;
    Parameter1.VStrings['OpenFile'] := OpenDialog1.FileName;
    Parameter1.VStrings['SaveFile'] := SaveDialog1.FileName;
    Parameter1.VStrings['FontName'] := FontDialog1.Font.Name;
    Parameter1['FontSize'] := FontDialog1.Font.Size;
    Parameter1.VFontStyles['FontStyle'] := FontDialog1.Font.Style;
    Parameter1['StartYear'] := UpDown1.Position;
    Parameter1['StartMonth'] := UpDown2.Position;
    Parameter1['Count'] := UpDown3.Position;
    Parameter1['StartPoint'] := UpDown4.Position;
    Parameter1['RowB'] := UpDown5.Position;
    Parameter1['ColB'] := UpDown6.Position;
    Parameter1['RowC'] := UpDown7.Position;
    Parameter1['ColC'] := UpDown8.Position;
    Parameter1['DayH'] := UpDown9.Position;
    Parameter1['DayW'] := UpDown10.Position;
    Parameter1['GapH'] := UpDown11.Position;
    Parameter1['GapW'] := UpDown12.Position;
    Parameter1.VBools['SundayRed'] := CheckBox1.Checked;
    Parameter1.VBools['HolidayRed'] := CheckBox2.Checked;
    Parameter1.VBools['Lines'] := CheckBox3.Checked;
    Parameter1.VStrings['CalendarLeft'] := Edit13.Text;
    Parameter1.VStrings['CalendarTop'] := Edit14.Text;
    Parameter1['PWindowState'] := Integer(wsNormal);
    Parameter1['PLeft'] := 240;
    Parameter1['PTop'] := 235;
    Parameter1['PClientWidth'] := 350;
    Parameter1['PClientHeight'] := 341;
    Parameter1['PrintRatio'] := 100;
    Parameter1['PreviewRatio'] := 20;
    Parameter1['GraphicMode'] := Integer(gmMetafile);
  end;

  FileName := ExtractFilePath(Application.ExeName) + 'Holiday.txt';
  if FileExists(FileName) then
    CalendarX1.Holiday.LoadFromFile(FileName);

  MakeOrgBitmap;

  Tag := 0;
  Button1Click(Sender);
end;

procedure TFrameForm.Button1Click(Sender: TObject);
var
  X: Integer;
begin
  if Tag = 1 then
    Exit;

  if not (CalendarX1.Picture.Graphic is TBitmap) then
    CalendarX1.Picture.Assign(OrgBitmap);

  CalendarX1.CalendarEnabled := False;
  CalendarX1.Canvas.Font := FontDialog1.Font;
  CalendarX1.StartYear := UpDown1.Position;
  CalendarX1.StartMonth := UpDown2.Position;
  CalendarX1.Count := UpDown3.Position;
  CalendarX1.StartPoint := UpDown4.Position;
  CalendarX1.RowB := UpDown5.Position;
  CalendarX1.ColB := UpDown6.Position;
  CalendarX1.RowC := UpDown7.Position;
  CalendarX1.ColC := UpDown8.Position;
  CalendarX1.DayH := UpDown9.Position;
  CalendarX1.DayW := UpDown10.Position;
  CalendarX1.GapH := UpDown11.Position;
  CalendarX1.GapW := UpDown12.Position;
  CalendarX1.SundayRed := CheckBox1.Checked;
  CalendarX1.HolidayRed := CheckBox2.Checked;
  CalendarX1.Lines := CheckBox3.Checked;
  CalendarX1.CalendarOnly := CheckBox4.Checked;
  try
    X := StrToInt(Edit13.Text);
  except
    X := 0;
  end;
  CalendarX1.CalendarLeft := X;
  try
    X := StrToInt(Edit14.Text);
  except
    X := 0;
  end;
  CalendarX1.CalendarTop := X;
  CalendarX1.CalendarEnabled := True;

  Caption := 'CalendarX  Version 0.2  --  ް  ( ' + 
             IntToStr(CalendarX1.Width) + ' ~ ' + IntToStr(CalendarX1.Height) +
             ' )  --  ';
  MakeOrgBitmap;

  CalendarX1.CalendarEnabled := False;
end;

procedure TFrameForm.Button2Click(Sender: TObject);
begin
  if FontDialog1.Execute then
    Button1Click(Sender);
end;

procedure TFrameForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
  FileName: TFileName;
begin
  Parameter1['WindowState'] := Integer(WindowState);
  if WindowState <> wsMaximized then
  begin
    Parameter1['Left'] := Left;
    Parameter1['Top'] := Top;
    Parameter1['ClientWidth'] := ClientWidth;
    Parameter1['ClientHeight'] := ClientHeight;
  end;
  if OpenDialog1.FileName <> '' then
    Parameter1.VStrings['OpenFile'] := OpenDialog1.FileName;
  if SaveDialog1.FileName <> '' then
    Parameter1.VStrings['SaveFile'] := SaveDialog1.FileName;
  Parameter1.VStrings['FontName'] := FontDialog1.Font.Name;
  Parameter1['FontSize'] := FontDialog1.Font.Size;
  Parameter1.VFontStyles['FontStyle'] := FontDialog1.Font.Style;
  Parameter1['StartYear'] := UpDown1.Position;
  Parameter1['StartMonth'] := UpDown2.Position;
  Parameter1['Count'] := UpDown3.Position;
  Parameter1['StartPoint'] := UpDown4.Position;
  Parameter1['RowB'] := UpDown5.Position;
  Parameter1['ColB'] := UpDown6.Position;
  Parameter1['RowC'] := UpDown7.Position;
  Parameter1['ColC'] := UpDown8.Position;
  Parameter1['DayH'] := UpDown9.Position;
  Parameter1['DayW'] := UpDown10.Position;
  Parameter1['GapH'] := UpDown11.Position;
  Parameter1['GapW'] := UpDown12.Position;
  Parameter1.VBools['SundayRed'] := CheckBox1.Checked;
  Parameter1.VBools['HolidayRed'] := CheckBox2.Checked;
  Parameter1.VBools['Lines'] := CheckBox3.Checked;
  Parameter1.VStrings['CalendarLeft'] := Edit13.Text;
  Parameter1.VStrings['CalendarTop'] := Edit14.Text;

  Parameter1.SaveToFile;

  FileName := ExtractFilePath(Application.ExeName) + 'Holiday.txt';
  CalendarX1.Holiday.SaveToFile(FileName);

  OrgBitmap.Free;
end;

procedure TFrameForm.Open1Click(Sender: TObject);
begin
  if Opendialog1.Execute then
  begin
    CheckBox4.Checked := False;
    CalendarX1.Picture.LoadFromFile(Opendialog1.FileName);

    Edit13.Text := '0'; Edit14.Text := '0';
    Caption := 'CalendarX  Version 0.2  --  ' + ExtractFileName(Opendialog1.FileName) +
               '  ' + SizeOfFile(Opendialog1.FileName) + '  ( ' +
               IntToStr(CalendarX1.Width) + ' ~ ' + IntToStr(CalendarX1.Height) +
               ' )  --  ';

    MakeOrgBitmap;
  end;
end;

procedure TFrameForm.Save1Click(Sender: TObject);
var
  Ext: String;
  Mf: TMetafile;
  MfCanvas: TMetafileCanvas;
  Jpeg: TJPEGImage;
  Gif: TGIFImage;
begin
  if CalendarX1.Picture.Graphic = Nil then
    Exit;

  if SaveDialog1.Execute then
  begin
    Ext := LowerCase(ExtractFileExt(SaveDialog1.FileName));
    if Ext = '.bmp' then
      OrgBitmap.SaveToFile(SaveDialog1.Filename)
    else if (Ext = '.emf') or (Ext = '.wmf') then
    begin
      Mf := TMetafile.Create;
      try
        Mf.Width := CalendarX1.Width;
        Mf.Height := CalendarX1.Height;
        MfCanvas := TMetafileCanvas.Create(Mf, GetDC(0));
        try
          MfCanvas.Draw(0, 0, OrgBitmap);
        finally
          MfCanvas.Free;
        end;
        Mf.SaveToFile(SaveDialog1.Filename);
      finally
        Mf.Free;
      end;
    end
    else if (Ext = '.jpg') or (Ext = '.jpeg') then
    begin
      Jpeg := TJPEGImage.Create;
      Jpeg.CompressionQuality := 70;
      try
        Jpeg.Assign(OrgBitmap);
        Jpeg.SaveToFile(SaveDialog1.Filename);
      finally
        Jpeg.Free;
      end;
    end
    else if Ext = '.gif' then
    begin
      Gif := TGIFImage.Create;
      try
        Gif.Assign(OrgBitmap);
        Gif.SaveToFile(SaveDialog1.Filename);
      finally
        Gif.Free;
      end;
    end
    else if Ext = '.txt' then
      CalendarX1.ListC.SaveToFile(SaveDialog1.Filename)
    else
      CalendarX1.Picture.SaveToFile(SaveDialog1.Filename);
  end;
end;

procedure TFrameForm.PrintPreview1Click(Sender: TObject);
begin
  if CalendarX1.Picture.Graphic = Nil then
    Exit;
  PreviewForm := TPreviewForm.Create(Self);
  PreviewForm.ShowModal;
  PreviewForm.Free;
end;

procedure TFrameForm.T1Click(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;

procedure TFrameForm.X1Click(Sender: TObject);
begin
  Close;
end;

procedure TFrameForm.SearchforHelpOn1Click(Sender: TObject);
var
  FileName: TFileName;
begin
  FileName := ExtractFilePath(Application.ExeName) + 'Readme.txt';
  ShellExecute(Handle, PChar('open'), PChar(FileName), Nil, Nil, SW_SHOW);
end;

procedure TFrameForm.About1Click(Sender: TObject);
begin
  ShellAbout(Handle, PChar(Application.Title),
             #13#10 + 'CalendarX  Version 0.2 Copyright (C) 2024 seizo',
             Application.Icon.Handle);
end;

procedure TFrameForm.Bitmap1Click(Sender: TObject);
begin
  Clipboard.Assign(OrgBitmap);
end;

procedure TFrameForm.Metafile1Click(Sender: TObject);
var
  Mf: TMetafile;
  MfCanvas: TMetafileCanvas;
begin
  Mf := TMetafile.Create;
  Mf.Enhanced := True;
  try
    Mf.Width := CalendarX1.Width;
    Mf.Height := CalendarX1.Height;
    MfCanvas := TMetafileCanvas.Create(Mf, GetDC(0));
    try
      MfCanvas.Draw(0, 0, OrgBitmap);
    finally
      MfCanvas.Free;
    end;
    Clipboard.Assign(Mf);
  finally
    Mf.Free;
  end;
end;

procedure TFrameForm.JPEG1Click(Sender: TObject);
var
  Jpeg: TJPEGImage;
  MemStream: TMemoryStream;
begin
  Jpeg := TJPEGImage.Create;
  Jpeg.CompressionQuality := 70;
  try
    Jpeg.Assign(OrgBitmap);
    MemStream := TMemoryStream.Create;
    try
      Jpeg.SaveToStream(MemStream);
      Stream2Clipboard(CF_JFIF, MemStream);
    finally
      MemStream.Free;
    end;
  finally
    Jpeg.Free;
  end;
end;

procedure TFrameForm.GIF1Click(Sender: TObject);
var
  Gif: TGIFImage;
  MemStream: TMemoryStream;
begin
  Gif := TGIFImage.Create;
  try
    Gif.Assign(OrgBitmap);
    MemStream := TMemoryStream.Create;
    try
      Gif.SaveToStream(MemStream);
      Stream2Clipboard(CF_GIF, MemStream);
    finally
      MemStream.Free;
    end;
  finally
    Gif.Free;
  end;
end;

procedure TFrameForm.Text1Click(Sender: TObject);
begin
  Clipboard.AsText := CalendarX1.ListC.Text;
end;

procedure TFrameForm.Paste1Click(Sender: TObject);
begin
  if Clipboard.HasFormat(CF_PICTURE) then
  begin
    CheckBox4.Checked := False;
    
    if Clipboard.HasFormat(CF_JFIF) then
      GetJPEG
    else if Clipboard.HasFormat(CF_GIF) then
      GetGIF
    else
      CalendarX1.Picture.Assign(Clipboard);

    Edit13.Text := '0'; Edit14.Text := '0';  
    Caption := 'CalendarX  Version 0.2  --  دް  ( ' +
               IntToStr(CalendarX1.Width) + ' ~ ' + IntToStr(CalendarX1.Height) +
               ' )  --  ';
      
    MakeOrgBitmap;
  end;
end;

procedure TFrameForm.CheckBox1Click(Sender: TObject);
begin
  Button1Click(Sender);
end;

procedure TFrameForm.CheckBox2Click(Sender: TObject);
begin
  Button1Click(Sender);
end;

procedure TFrameForm.CheckBox3Click(Sender: TObject);
begin
  Button1Click(Sender);
end;

procedure TFrameForm.CheckBox4Click(Sender: TObject);
begin
  Button1Click(Sender);
end;

procedure TFrameForm.N5Click(Sender: TObject);
var
  FileName: TFileName;
begin
  FileName := ExtractFilePath(Application.ExeName) + 'Holiday.txt';
  if FileExists(FileName) then
  begin
    ShellExecute(Handle, PChar('open'), PChar(FileName), Nil, Nil, SW_SHOW);
    CalendarX1.Holiday.LoadFromFile(FileName);
  end;
end;

procedure TFrameForm.N4Click(Sender: TObject);
begin
  Tag := 1;

  WindowState := wsNormal;
  Left := 192;
  Top := 114;
  ClientWidth := 688;
  ClientHeight := 447;
  FontDialog1.Font.Name := 'lr SVbN';
  FontDialog1.Font.Size := 9;
  FontDialog1.Font.Style := [];
  UpDown1.Position := 2025;
  UpDown2.Position := 1;
  UpDown3.Position := 12;
  UpDown4.Position := 1;
  UpDown5.Position := 4;
  UpDown6.Position := 3;
  UpDown7.Position := 1;
  UpDown8.Position := 1;
  UpDown9.Position := 1;
  UpDown10.Position := 3;
  UpDown11.Position := 1;
  UpDown12.Position := 2;
  CheckBox1.Checked := False;
  CheckBox2.Checked := False;
  CheckBox3.Checked := False;
  CheckBox4.Checked := True;
  Edit13.Text := '0';
  Edit14.Text := '0';
  Parameter1['PWindowState'] := 0;
  Parameter1['PLeft'] := 240;
  Parameter1['PTop'] := 235;
  Parameter1['PClientWidth'] := 350;
  Parameter1['PClientHeight'] := 341;
  Parameter1['PrintRatio'] := 100;
  Parameter1['PreviewRatio'] := 20;
  Parameter1['GraphicMode'] := Integer(gmMetafile);

  Tag := 0;
  Button1Click(Sender);
end;

procedure TFrameForm.CalendarX1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  S: String;
  E: TSize;
begin
  if Button = mbRight then
  begin
    X := 0; Y := 0;
  end;

  if ssShift in Shift then
  begin
    S := '5';
    E := OrgBitmap.Canvas.TextExtent(S);
    X := X - E.cx * UpDown12.Position;
    Y := Y - E.cy * UpDown11.Position;
  end;
  Edit13.Text := IntToStr(X);
  Edit14.Text := IntToStr(Y);
end;

initialization
  CF_JFIF := RegisterClipboardFormat('JFIF');
  TPicture.RegisterClipboardFormat(CF_JFIF, TJPEGImage);
  RegisterClass(TJPEGImage);

  CF_GIF := RegisterClipboardFormat('GIF Image');
  TPicture.RegisterClipboardFormat(CF_GIF, TGIFImage);
  RegisterClass(TGIFImage);

end.
